//---------------------------------------------------------------------------

#include <vcl.h>
#include <windows.h>
#pragma hdrstop

/* Copyright (c) by DATATEC Computer u. Elektronik GmbH

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

******************************************************************
** Excuse please.  CBuilder and the English language is not my strength!
** BackUp.cpp DLL version 1.01
**
** Author Ch. Friedrich 28.5.2001
**
** Dependencies: libmysql.dll
** Output:       MyBackUp.dll
**
*******************************************************************/


#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
        return 1;
}
//---------------------------------------------------------------------------

#include "DumpFunc.h"
#include "MyObj.h"
#include "LibMySql.hpp"
#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>


MYSQL * MyHandle;
char  MyDB[100];
int UpdTables,LibIsLoadet=0;
TMySQLObj MySqlObj;
TMyDumpObj MyDuObj;


extern "C" int FAR PASCAL _export InitUpdDLL()
{
  UpdTables=0;
  if (LibIsLoadet) return 1;
  if (LibIsLoadet=MySqlLoadLib())
   {
    MyHandle = NULL;
    return 1;
   } else return 0;
}


extern "C" int FAR PASCAL _export ConnectServer(char *host,char *DB,char *user,char *passwd)
{
  if (DB) strcpy(MyDB, DB);
  else strcpy(MyDB, "mysql");
  MyHandle=MySqlObj.RealConnectServer(host, user, passwd, MyDB);
  MyDuObj.current_host=host;
  return MySqlObj.Connected;
}

extern "C" int FAR PASCAL _export DoBackUp(char *DB,char *Table, char *SqlFileName, int MultiFiles)
{
  static char wrOpt[4];
  int   numFields;
  FILE  *sqf;

 strcpy(wrOpt,"wt");
 if ( MultiFiles ) strcpy(wrOpt,"at+");
 strcpy(MyDB, DB);
 if ((MySqlObj.Connected) && ( mysql_select_db(MyHandle, MyDB ) > -1))
  {
      if( (sqf = fopen(SqlFileName, wrOpt)) != NULL)
      {
        MyDuObj.DpO.Write_heder=1;
        if ((UpdTables) && (MultiFiles)) MyDuObj.DpO.Write_heder=0;
        numFields=MyDuObj.getTableStructure(MyHandle,Table, MyDB, sqf);
        if (numFields)
        {
         MyDuObj.dumpTable(numFields, Table, sqf);
         UpdTables++;
        }
        fclose(sqf);
        return 1;
      } else return 0;
  } else return 0;
}


extern "C" int FAR PASCAL _export  GetTableStruct(char *DB,char *Table, char *SqlFileName, int MultiFiles)
{
  static char wrOpt[4];
  int       numFields;
  FILE       *sqf;

 strcpy(wrOpt,"wt");
 if ( MultiFiles ) strcpy(wrOpt,"at+");
 strcpy(MyDB, DB);
 if ((MySqlObj.Connected) && ( mysql_select_db(MyHandle, MyDB ) > -1))
  {
      if( (sqf = fopen(SqlFileName, wrOpt)) != NULL)
      {
        numFields=MyDuObj.getTableStructure(MyHandle,Table, MyDB, sqf);
        fclose(sqf);
        return numFields ;
      } else return 0;
  } else return 0;
}


extern "C" int FAR PASCAL _export ExecQuery(char *SqlStr)
{
  return MySqlObj.ExecSQL(SqlStr);
}


extern "C" void FAR PASCAL _export DisConnect()
{
 MySqlObj.DisConnect();
}

// For database-show, first call this function
// Result gives the database found first
extern "C" char * FAR PASCAL _export FindFirstDb()
{
  if (MySqlObj.FindFirstDatabase()) return MySqlObj.FindName;
  else return "";
}

extern "C" char * FAR PASCAL _export FindNextDb()
{
  MySqlObj.FindNextDatabases();
  return MySqlObj.FindName;
}


// For table-show, first call this function
// Result gives the file found first
extern "C" char * FAR PASCAL _export FindFirstTb(char *DB)
{
  if (MySqlObj.FindFirstTable(DB)) return MySqlObj.FindName;
  else return "";
}

// After FindFirstTb - call FindNextTb, as long as the result is not empty.
extern "C" char * FAR PASCAL _export FindNextTb()
{
  MySqlObj.FindNextTable();
  return MySqlObj.FindName;
}

// The result are the secured data records of the table.
extern "C" unsigned int FAR PASCAL _export GetRecord()
{
  return MyDuObj.TbRecords;
}


extern "C" char * FAR PASCAL _export LastMyError()
{
  return  MySqlObj.MyErrStr;
}

extern "C" int FAR PASCAL _export LastMyErrorNo()
{
  return  MySqlObj.MyErrNo;
}

// Select the database
extern "C" int FAR PASCAL _export SelectMyDB(char *database)
{
  return  MySqlObj.SelectDB(database);
}

// Return Values:
// Zero if the server is alive. Non-zero if an error occurred.
extern "C" int FAR PASCAL _export SendPing()
{
  return  MySqlObj.PingServer();
}


extern "C" void FAR PASCAL _export SetProgressBar(TProgressBar *MyProgr)
{
  MyDuObj.MyProgress =MyProgr;
}

extern "C" void FAR PASCAL _export SetProgressStep(unsigned int Value)
{
  MyDuObj.ProgrStep =Value;
}


extern "C" char * FAR PASCAL _export GetDumpVersion()
{
  return MyDuObj.DmpVersion();
}


//Here you set the options for the dump.

extern "C" void FAR PASCAL _export SetLockOption(unsigned int Value)
{
  MyDuObj.DpO.opt_lock=Value;
}

extern "C" void FAR PASCAL _export Set_C_FlagOption(unsigned int Value)
{
  MyDuObj.DpO.cFlag=Value;
}

extern "C" void FAR PASCAL _export Set_T_FlagOption(unsigned int Value)
{
  MyDuObj.DpO.tFlag =Value;
}

extern "C" void FAR PASCAL _export SetDropOption(unsigned int Value)
{
  MyDuObj.DpO.opt_drop=Value;
}

extern "C" void FAR PASCAL _export SetWhereOption(char * StrValue, unsigned int Value)
{
  MyDuObj.DpO.WhereStr=StrValue;
  MyDuObj.DpO.opt_where=Value;
}

extern "C" void FAR PASCAL _export SetExInsOption(unsigned int Value)
{
  MyDuObj.DpO.extended_insert =Value;
}


